import { Duration } from 'aws-cdk-lib';
import { IStateMachine } from 'aws-cdk-lib/aws-stepfunctions';
import { IConstruct } from 'constructs';
import { IIssueParser } from '../issue-manager';
import { IssuePluginBase, IssuePluginBaseProps } from '../issue-plugin-base';
import { IssueTrigger } from '../issue-trigger';
export interface IssueParserPluginBaseProps extends IssuePluginBaseProps {
    readonly matchType?: string;
    readonly name?: string;
    readonly timeout?: Duration;
}
export declare abstract class IssueParserPluginBase extends IssuePluginBase implements IIssueParser {
    readonly name?: string;
    readonly timeout?: Duration;
    abstract readonly handler: IStateMachine;
    readonly matchType: string;
    get triggers(): IssueTrigger[];
    constructor(scope: IConstruct, id: string, props?: IssueParserPluginBaseProps);
    protected abstract addDefaultTrigger(): IssueTrigger;
    bind(_node: IConstruct): IssueTrigger[];
}
