import { IConstruct } from 'constructs';
import { ConfigComplianceChange, ConfigComplianceChangeProps } from './config-compliance-change';
import { EcrScanFinding, EcrScanFindingProps } from './ecr-scan-finding';
import { GuardDutyFinding, GuardDutyFindingProps } from './guard-duty-finding';
import { InspectorFinding, InspectorFindingProps } from './inspector-finding';
import { OpenSearchEvent, OpenSearchEventProps } from './opensearch-event';
import { SecurityHubFinding, SecurityHubFindingProps } from './security-hub-finding';
export declare class IssueParser {
    static configComplianceChange(scope: IConstruct, id: string, props?: ConfigComplianceChangeProps): ConfigComplianceChange;
    static ecrScanFinding(scope: IConstruct, id: string, props?: EcrScanFindingProps): EcrScanFinding;
    static guardDutyFinding(scope: IConstruct, id: string, props?: GuardDutyFindingProps): GuardDutyFinding;
    static inspectorFinding(scope: IConstruct, id: string, props?: InspectorFindingProps): InspectorFinding;
    static openSearchEvent(scope: IConstruct, id: string, props?: OpenSearchEventProps): OpenSearchEvent;
    static securityHubFinding(scope: IConstruct, id: string, props?: SecurityHubFindingProps): SecurityHubFinding;
}
